package dojox.cometd;


/* ------------------------------------------------------------ */
/** Cometd Receiver interface.
 * A receive in an object that can receive a message for a Bayeux {@link Client}.
 * 
 * @author gregw
 *
 */
public interface Listener
{
    /**
     * This method is called when the client is removed (explicitly or from a timeout)
     */
    public void removed();
    
    /**
     * Called when a message is delivered to the client
     */
    public void deliver(Client fromClient, String toChannel, Object data,String msgId);
}
